import argparse
from simulate import EventSimulator
import random
from network import Network

def parse_cmd():
    """
    Parse command line arguments
    """
    parser = argparse.ArgumentParser()
    parser.add_argument('-n', '--num_nodes', type = int, default = 50, help="Number of nodes in the network")
    parser.add_argument('--z0', type = int, default = 10, help="percentage of node with slow bandwidth")
    parser.add_argument('--z1', type = int, default = 10, help="percentage of node with low CPU")
    parser.add_argument('--T_tx', type = int, default = 10, help="Interarrival time between transactions")
    parser.add_argument('--I', type = int, default = 100, help="Interarrival time between blocks")
    parser.add_argument('--T_dij', type = int, default = 10, help="Mean of queuing delay")
    #parser.add_argument('--pij', type = int, default = 10, help="speed of light propagation delay")
    parser.add_argument('--sim_time', type = int, default = 100, help="Simulation time in seconds")
    parser.add_argument('--seed', type = int, default = 0, help="Seed for random number generator")
    return parser.parse_args()

if __name__ == '__main__':
    args = parse_cmd()
    random.seed(args.seed)
    
    print(args)
    
    sim = EventSimulator(args)
    nx = Network(sim, args)

    sim.startSimulation()
    exit(0)